/**
* {{description}}{{^description}}{{classname}}{{/description}}
*/
{{>additionalModelTypeAnnotations}}
{{#description}}
    {{#swagger1AnnotationLibrary}}
        @ApiModel(description = "{{{description}}}")
    {{/swagger1AnnotationLibrary}}
    {{#swagger2AnnotationLibrary}}
        @Schema({{#name}}name = "{{name}}", {{/name}}description = "{{{description}}}")
    {{/swagger2AnnotationLibrary}}
{{/description}}
{{#discriminator}}
    {{>typeInfoAnnotation}}
{{/discriminator}}
{{#jackson}}
    {{#isClassnameSanitized}}
        {{^hasDiscriminatorWithNonEmptyMapping}}
            @JsonTypeName("{{name}}")
        {{/hasDiscriminatorWithNonEmptyMapping}}
    {{/isClassnameSanitized}}
{{/jackson}}
{{#withXml}}
    {{>xmlAnnotation}}
{{/withXml}}
{{>generatedAnnotation}}
{{#vendorExtensions.x-class-extra-annotation}}
    {{{vendorExtensions.x-class-extra-annotation}}}
{{/vendorExtensions.x-class-extra-annotation}}
public class {{classname}}{{#parent}} extends {{{parent}}}{{/parent}}{{^parent}}{{#hateoas}} extends RepresentationModel<{{classname}}> {{/hateoas}}{{/parent}}{{#vendorExtensions.x-implements}}{{#-first}} implements {{{.}}}{{/-first}}{{^-first}}, {{{.}}}{{/-first}}{{/vendorExtensions.x-implements}} {
{{#serializableModel}}

    private static final long serialVersionUID = 1L;
{{/serializableModel}}
{{#vars}}

    {{#isEnum}}
        {{^isContainer}}
            {{>enumClass}}
        {{/isContainer}}
        {{#isContainer}}
            {{#mostInnerItems}}
                {{>enumClass}}
            {{/mostInnerItems}}
        {{/isContainer}}
    {{/isEnum}}
    {{#jackson}}
        {{#withXml}}
            @JacksonXmlProperty({{#isXmlAttribute}}isAttribute = true, {{/isXmlAttribute}}{{#xmlNamespace}}namespace="{{.}}", {{/xmlNamespace}}localName = "{{xmlName}}{{^xmlName}}{{baseName}}{{/xmlName}}")
        {{/withXml}}
    {{/jackson}}
    {{#gson}}
        @SerializedName("{{baseName}}")
    {{/gson}}
    {{#vendorExtensions.x-field-extra-annotation}}
        {{{vendorExtensions.x-field-extra-annotation}}}
    {{/vendorExtensions.x-field-extra-annotation}}
    {{#required}}@{{javaxPackage}}.validation.constraints.NotNull{{/required}}
    {{#isContainer}}
        {{#useBeanValidation}}@Valid{{/useBeanValidation}}
        {{#openApiNullable}}
            private {{>nullableDataType}} {{name}}{{#isNullable}} = JsonNullable.undefined(){{/isNullable}}{{^isNullable}}{{#defaultValue}} = {{{.}}}{{/defaultValue}}{{/isNullable}};
        {{/openApiNullable}}
        {{^openApiNullable}}
            private {{>nullableDataType}} {{name}}{{#defaultValue}} = {{{.}}}{{/defaultValue}};
        {{/openApiNullable}}
    {{/isContainer}}
    {{^isContainer}}
        {{#isDate}}
            @DateTimeFormat(iso = DateTimeFormat.ISO.DATE)
        {{/isDate}}
        {{#isDateTime}}
            @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
        {{/isDateTime}}
        {{#openApiNullable}}
            private {{>nullableDataType}} {{name}}{{#isNullable}} = JsonNullable.undefined(){{/isNullable}}{{^isNullable}}{{#defaultValue}} = {{{.}}}{{/defaultValue}}{{/isNullable}};
        {{/openApiNullable}}
        {{^openApiNullable}}
            private {{>nullableDataType}} {{name}}{{#isNullable}} = null{{/isNullable}}{{^isNullable}}{{#defaultValue}} = {{{.}}}{{/defaultValue}}{{/isNullable}};
        {{/openApiNullable}}
    {{/isContainer}}
{{/vars}}
{{#generatedConstructorWithRequiredArgs}}
    {{#hasRequired}}

        /**
        * Default constructor
        * @deprecated Use {@link {{classname}}#{{classname}}({{#requiredVars}}{{{datatypeWithEnum}}}{{^-last}}, {{/-last}}{{/requiredVars}})}
        */
        @Deprecated
        public {{classname}}() {
        super();
        }

        /**
        * Constructor with only required parameters
        */
        public {{classname}}({{#requiredVars}}{{{datatypeWithEnum}}} {{name}}{{^-last}}, {{/-last}}{{/requiredVars}}) {
        {{#parent}}
            super({{#parentRequiredVars}}{{name}}{{^-last}}, {{/-last}}{{/parentRequiredVars}});
        {{/parent}}
        {{#vars}}
            {{#required}}
                {{#openApiNullable}}
                    this.{{name}} = {{#isNullable}}JsonNullable.of({{name}}){{/isNullable}}{{^isNullable}}{{name}}{{/isNullable}};
                {{/openApiNullable}}
                {{^openApiNullable}}
                    this.{{name}} = {{name}};
                {{/openApiNullable}}
            {{/required}}
        {{/vars}}
        }
    {{/hasRequired}}
{{/generatedConstructorWithRequiredArgs}}
{{#vars}}

{{! begin feature: fluent setter methods }}
    public {{classname}} {{name}}({{{datatypeWithEnum}}} {{name}}) {
    {{#openApiNullable}}
        this.{{name}} = {{#isNullable}}JsonNullable.of({{name}}){{/isNullable}}{{^isNullable}}{{name}}{{/isNullable}};
    {{/openApiNullable}}
    {{^openApiNullable}}
        this.{{name}} = {{name}};
    {{/openApiNullable}}
    return this;
    }
    {{#isArray}}

        public {{classname}} add{{nameInCamelCase}}Item({{{items.datatypeWithEnum}}} {{name}}Item) {
        {{#openApiNullable}}
            if (this.{{name}} == null{{#isNullable}} || !this.{{name}}.isPresent(){{/isNullable}}) {
            this.{{name}} = {{#isNullable}}JsonNullable.of({{/isNullable}}{{{defaultValue}}}{{^defaultValue}}new {{#uniqueItems}}LinkedHashSet{{/uniqueItems}}{{^uniqueItems}}ArrayList{{/uniqueItems}}<>(){{/defaultValue}}{{#isNullable}}){{/isNullable}};
            }
            this.{{name}}{{#isNullable}}.get(){{/isNullable}}.add({{name}}Item);
        {{/openApiNullable}}
        {{^openApiNullable}}
            if (this.{{name}} == null) {
            this.{{name}} = {{{defaultValue}}}{{^defaultValue}}new {{#uniqueItems}}LinkedHashSet{{/uniqueItems}}{{^uniqueItems}}ArrayList{{/uniqueItems}}<>(){{/defaultValue}};
            }
            this.{{name}}.add({{name}}Item);
        {{/openApiNullable}}
        return this;
        }
    {{/isArray}}
    {{#isMap}}

        public {{classname}} put{{nameInCamelCase}}Item(String key, {{{items.datatypeWithEnum}}} {{name}}Item) {
        if (this.{{name}} == null) {
        this.{{name}} = {{{defaultValue}}}{{^defaultValue}}new HashMap<>(){{/defaultValue}};
        }
        this.{{name}}.put(key, {{name}}Item);
        return this;
        }
    {{/isMap}}
    {{! end feature: fluent setter methods }}
    {{! begin feature: getter and setter }}

    /**
    {{#description}}
        * {{{.}}}
    {{/description}}
    {{^description}}
        * Get {{name}}
    {{/description}}
    {{#minimum}}
        * minimum: {{.}}
    {{/minimum}}
    {{#maximum}}
        * maximum: {{.}}
    {{/maximum}}
    * @return {{name}}
    */
    {{#vendorExtensions.x-extra-annotation}}
        {{{vendorExtensions.x-extra-annotation}}}
    {{/vendorExtensions.x-extra-annotation}}
    {{#useBeanValidation}}
        {{>beanValidation}}
    {{/useBeanValidation}}
    {{^useBeanValidation}}
        {{#required}}@{{javaxPackage}}.validation.constraints.NotNull{{/required}}
    {{/useBeanValidation}}
    {{#swagger2AnnotationLibrary}}
        @Schema(name = "{{{baseName}}}"{{#isReadOnly}}, accessMode = Schema.AccessMode.READ_ONLY{{/isReadOnly}}{{#example}}, example = "{{{.}}}"{{/example}}{{#description}}, description = "{{{.}}}"{{/description}}, requiredMode = {{#required}}Schema.RequiredMode.REQUIRED{{/required}}{{^required}}Schema.RequiredMode.NOT_REQUIRED{{/required}})
    {{/swagger2AnnotationLibrary}}
    {{#swagger1AnnotationLibrary}}
        @ApiModelProperty({{#example}}example = "{{{.}}}", {{/example}}{{#required}}required = {{required}}, {{/required}}{{#isReadOnly}}readOnly = {{{isReadOnly}}}, {{/isReadOnly}}value = "{{{description}}}")
    {{/swagger1AnnotationLibrary}}
    {{#jackson}}
        @JsonProperty("{{baseName}}")
    {{/jackson}}
    public {{>nullableDataType}} {{getter}}() {
    return {{name}};
    }

    {{#vendorExtensions.x-setter-extra-annotation}}
        {{{vendorExtensions.x-setter-extra-annotation}}}
    {{/vendorExtensions.x-setter-extra-annotation}}
    public void {{setter}}({{#required}}@NotNull{{/required}} {{#useBeanValidation}}{{>beanValidation}}{{/useBeanValidation}} {{>nullableDataType}} {{name}}) {
    this.{{name}} = {{name}};
    }
{{! end feature: getter and setter }}
{{/vars}}
{{#parentVars}}

{{! begin feature: fluent setter methods for inherited properties }}
    public {{classname}} {{name}}({{{datatypeWithEnum}}} {{name}}) {
    super.{{setter}}({{name}});
    return this;
    }
    {{#isArray}}

        public {{classname}} add{{nameInCamelCase}}Item({{{items.datatypeWithEnum}}} {{name}}Item) {
        super.add{{nameInCamelCase}}Item({{name}}Item);
        return this;
        }
    {{/isArray}}
    {{#isMap}}

        public {{classname}} put{{nameInCamelCase}}Item(String key, {{{items.datatypeWithEnum}}} {{name}}Item) {
        super.put{{nameInCamelCase}}Item(key, {{name}}Item);
        return this;
        }
    {{/isMap}}
{{! end feature: fluent setter methods for inherited properties }}
{{/parentVars}}

@Override
public boolean equals(Object o) {
if (this == o) {
return true;
}
if (o == null || getClass() != o.getClass()) {
return false;
}{{#hasVars}}
    {{classname}} {{classVarName}} = ({{classname}}) o;
    return {{#vars}}{{#vendorExtensions.x-is-jackson-optional-nullable}}equalsNullable(this.{{name}}, {{classVarName}}.{{name}}){{/vendorExtensions.x-is-jackson-optional-nullable}}{{^vendorExtensions.x-is-jackson-optional-nullable}}{{#isByteArray}}Arrays{{/isByteArray}}{{^isByteArray}}Objects{{/isByteArray}}.equals(this.{{name}}, {{classVarName}}.{{name}}){{/vendorExtensions.x-is-jackson-optional-nullable}}{{^-last}} &&
    {{/-last}}{{/vars}}{{#parent}} &&
    super.equals(o){{/parent}};{{/hasVars}}{{^hasVars}}
    return true;{{/hasVars}}
}
{{#vendorExtensions.x-jackson-optional-nullable-helpers}}

    private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
        return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
        }
{{/vendorExtensions.x-jackson-optional-nullable-helpers}}

    @Override
    public int hashCode() {
    return Objects.hash({{#vars}}{{#vendorExtensions.x-is-jackson-optional-nullable}}hashCodeNullable({{name}}){{/vendorExtensions.x-is-jackson-optional-nullable}}{{^vendorExtensions.x-is-jackson-optional-nullable}}{{^isByteArray}}{{name}}{{/isByteArray}}{{#isByteArray}}Arrays.hashCode({{name}}){{/isByteArray}}{{/vendorExtensions.x-is-jackson-optional-nullable}}{{^-last}}, {{/-last}}{{/vars}}{{#parent}}{{#hasVars}}, {{/hasVars}}super.hashCode(){{/parent}});
    }
{{#vendorExtensions.x-jackson-optional-nullable-helpers}}

        private static <T> int hashCodeNullable(JsonNullable<T> a) {
        if (a == null) {
        return 1;
        }
        return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
        }
{{/vendorExtensions.x-jackson-optional-nullable-helpers}}

    @Override
    public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class {{classname}} {\n");
{{#parent}}
        sb.append("    ").append(toIndentedString(super.toString())).append("\n");
{{/parent}}
{{#vars}}
        sb.append("    {{name}}: ").append({{^isPassword}}toIndentedString({{name}}){{/isPassword}}{{#isPassword}}"*****"{{/isPassword}}).append("\n");
{{/vars}}sb.append("}");
    return sb.toString();
    }

    /**
    * Convert the given object to string with each line indented by 4 spaces
    * (except the first line).
    */
    private String toIndentedString(Object o) {
    if (o == null) {
    return "null";
    }
    return o.toString().replace("\n", "\n    ");
    }
    }
